//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit EventBuilder;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, Events, Map, ComCtrls;

type
  TEventBuilderForm = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    WarpNum: TSpinEdit;
    SignNum: TSpinEdit;
    PeopNum: TSpinEdit;
    Button2: TButton;
    CurrentAddrEdit: TEdit;
    Label4: TLabel;
    StatusBar1: TStatusBar;
    Label5: TLabel;
    TrigNum: TSpinEdit;
    procedure EventSpinChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    MapHdr2Addr: Integer;
    MapHdr1: TMapHeader1;
    MapHdr2: TMapHeader2;
    CurrentEventSize: Integer;
    NewEventSize: Integer;
    NewEventAddr: Integer;
  end;

var
  EventBuilderForm: TEventBuilderForm;

implementation

uses Main;

{$R *.DFM}

procedure TEventBuilderForm.EventSpinChange(Sender: TObject);
begin
NewEventSize := 2 + (WarpNum.Value * SizeOf(TWarp)) + (TrigNum.Value * SizeOf(TTrigger)) + (SignNum.Value * SizeOf(TSignPost)) + (PeopNum.Value * SizeOf(TPeople));
if NewEventSize > CurrentEventSize then
 begin
 //NewEventAddr := FindFreeSpace;
 StatusBar1.SimpleText := 'Event data size exceeds the allocated space!'
 end
else
 begin
 //NewEventAddr := EventsAddr;
 StatusBar1.SimpleText := 'Events fit in allocated space.'
 end;
//NewAddrEdit.Text := '$'+ IntToHex(NewEventAddr,6) + ' (' + IntToHex(GBBank(NewEventAddr),2) + ':' + IntToHex(NewEventAddr mod $4000 + $4000,4) + ')';
end;

procedure TEventBuilderForm.Button1Click(Sender: TObject);
const
ZeroWord: Word = $0000;
WarpData: array [1..5] of Byte = (0,0,1,24,5);
TrigData: array [1..8] of Byte = (0,0,1,0,0,0,0,0);
SignData: array [1..5] of Byte = (0,2,0,200,64);
PeopData: array [1..13] of Byte = (41,0,3,3,1,255,255,0,0,111,64,255,255);
var
B: Byte;
I: Integer;
begin
if NewEventSize > CurrentEventSize then
 begin
 if MessageDlg('The new events will require more space than current ones. Do you want to write them to rom anyway? This may cause game corruption. (This version of GoldMap does not yet support repointing event data.)',mtWarning,[mbYes,mbNo],0) = mrNo then
 Exit;
 end;
//the old event data will be first zeroed to mark it as "free space"
B := 0;
Rom.Position := EventsAddr;
for I := 0 to CurrentEventSize - 1 do
Rom.Write(B,1);
{//let's see if MapHeader2 needs modification
if EventsAddr <> NewEventAddr then
 begin
 MapHdr2.TextAndEventBank := GBBank(NewEventAddr);
 MapHdr2.EventAddress     := (NewEventAddr mod $4000) + $4000;
 Rom.Position := MapHdr2Addr;
 Rom.Write(MapHdr2,SizeOf(MapHdr2));
 end;
Rom.Position := NewEventAddr;}
Rom.Position := EventsAddr;
Rom.Write(ZeroWord,2);
B := WarpNum.Value; Rom.Write(B,1);
for I := 0 to B - 1 do
 begin
 Rom.Write(WarpData,SizeOf(TWarp));
 end;
B := TrigNum.Value; Rom.Write(B,1);
for I := 0 to B - 1 do
 begin
 Rom.Write(TrigData,SizeOf(TTrigger));
 end;
B := SignNum.Value; Rom.Write(B,1);
for I := 0 to B - 1 do
 begin
 Rom.Write(SignData,SizeOf(TSignpost));
 end;
B := PeopNum.Value; Rom.Write(B,1);
for I := 0 to B - 1 do
 begin
 Rom.Write(PeopData,SizeOf(TPeople));
 end;
LoadEvents(EventsAddr);
Close;
end;

procedure TEventBuilderForm.Button2Click(Sender: TObject);
begin
Close;
end;



procedure TEventBuilderForm.FormCreate(Sender: TObject);
begin
MapHdr1 := GetMapHeader1(GetMapHeader1Addr(LoadedMapBank,LoadedMapNum));
MapHdr2Addr := GBPtrToFilePos(MapHdr1.Header2Bank,MapHdr1.Header2Addr);
MapHdr2 := GetMapHeader2(MapHdr1);
CurrentAddrEdit.Text := '$'+ IntToHex(EventsAddr,6) + ' (' + IntToHex(MapHdr2.TextAndEventBank,2) + ':' + IntToHex(MapHdr2.EventAddress,4) + ')';
//NewAddrEdit.Text := CurrentAddrEdit.Text;
CurrentEventSize := 2 + (NumOfWarp * SizeOf(TWarp)) + (NumOfTrigger * SizeOf(TTrigger)) + (NumOfSignpost * SizeOf(TSignPost)) + (NumOfPeople * SizeOf(TPeople));
NewEventSize := CurrentEventSize;
WarpNum.Value := NumOfWarp;
TrigNum.Value := NumOfTrigger;
SignNum.Value := NumOfSignpost;
PeopNum.Value := NumOfPeople;
end;

end.
