//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit Signpost;

interface

uses
  Graphics, SysUtils, Controls, Forms, Dialogs, Spin, Events, Classes, StdCtrls;

type
  TSignpostForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    TextBlockSpin: TSpinEdit;
    TextBankSpin: TSpinEdit;
    HiddenCheck: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure TextBlockSpinChange(Sender: TObject);
    procedure TextBankSpinChange(Sender: TObject);
    procedure HiddenCheckClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  end;

var
  SignpostForm: TSignpostForm = nil;

implementation

uses Main;

{$R *.DFM}

procedure TSignpostForm.FormActivate(Sender: TObject);
begin
Caption := 'Signpost ' + IntToStr(SelectedEvent.Number);
TextBlockSpin.Value := Signposts[SelectedEvent.Number].TextBlock;
TextBankSpin.Value  := Signposts[SelectedEvent.Number].TextBank;
HiddenCheck.Checked := Signposts[SelectedEvent.Number].Func <> 0;
end;

procedure TSignpostForm.TextBlockSpinChange(Sender: TObject);
begin
Signposts[SelectedEvent.Number].TextBlock := TextBlockSpin.Value;
end;

procedure TSignpostForm.TextBankSpinChange(Sender: TObject);
begin
Signposts[SelectedEvent.Number].TextBank := TextBankSpin.Value;
end;

procedure TSignpostForm.HiddenCheckClick(Sender: TObject);
begin
if HiddenCheck.Checked then
Signposts[SelectedEvent.Number].Func := 7
else
Signposts[SelectedEvent.Number].Func := 0;
end;

procedure TSignpostForm.FormShow(Sender: TObject);
begin
//try to position event window nicely
if MainForm.EventScrollBox.Width < MainForm.EventBox.Width then
Left := MainForm.MapTree.Width + MainForm.Left + MainForm.EventScrollBox.Width + 32 + Random(32)
else
Left := MainForm.MapTree.Width + MainForm.Left + MainForm.EventBox.Width + 32 + Random(32);
if Left + Width > Screen.WorkAreaRect.Right then
Left := Screen.WorkAreaRect.Right - (Width + 16);
end;

end.
